#include <time.h>
#include <allegro.h>
#include <sys/time.h>
#include <sys/times.h>

#include "timefunc.h"

long GetTimeTicks(void)
{
	struct timeval tv;		
	static LONG_LONG first=-1;
	LONG_LONG ll;
	
	if (first < 0)
	{
		if (gettimeofday(&tv, NULL) != 0)
			return (long)((((LONG_LONG)clock())*TICKSPERSEC)/CLOCKS_PER_SEC);
		
		first=((LONG_LONG)tv.tv_sec)*1000000 + tv.tv_usec;
	}
	
	if (gettimeofday(&tv, NULL) == 0)
	{
		ll=((LONG_LONG)tv.tv_sec)*1000000 + tv.tv_usec;
		return (long) (((ll-first)*TICKSPERSEC)/1000000);
	}
	
	return (long)((((LONG_LONG)clock())*TICKSPERSEC)/CLOCKS_PER_SEC);
}
